/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomHTMLTableElement_H__
#define __GdomHTMLTableElement_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomHTMLElement.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomHTMLTableElement GdomHTMLTableElement;
typedef struct _GdomHTMLTableElementClass GdomHTMLTableElementClass;


#define GDOM_TYPE_HTML_TABLE_ELEMENT            (gdom_html_table_element_get_type())
#define GDOM_HTML_TABLE_ELEMENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_HTML_TABLE_ELEMENT, GdomHTMLTableElement))
#define GDOM_HTML_TABLE_ELEMENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_HTML_TABLE_ELEMENT, GdomHTMLTableElement)Class)
#define GDOM_IS_HTML_TABLE_ELEMENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_HTML_TABLE_ELEMENT))
#define GDOM_IS_HTML_TABLE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_HTML_TABLE_ELEMENT))
#define GDOM_HTML_TABLE_ELEMENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_HTML_TABLE_ELEMENT, GdomHTMLTableElementClass))

typedef struct _GdomHTMLTableElementPrivate GdomHTMLTableElementPrivate;

struct _GdomHTMLTableElement {
    GdomHTMLElement parent_instance;
    GdomHTMLTableElementPrivate *priv;
};

struct _GdomHTMLTableElementClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_html_table_element_get_type (void);

WEBKIT_API GdomHTMLElement *
gdom_html_table_element_create_t_head (GdomHTMLTableElement *thiz);

WEBKIT_API void
gdom_html_table_element_delete_t_head (GdomHTMLTableElement *thiz);

WEBKIT_API GdomHTMLElement *
gdom_html_table_element_create_t_foot (GdomHTMLTableElement *thiz);

WEBKIT_API void
gdom_html_table_element_delete_t_foot (GdomHTMLTableElement *thiz);

WEBKIT_API GdomHTMLElement *
gdom_html_table_element_create_caption (GdomHTMLTableElement *thiz);

WEBKIT_API void
gdom_html_table_element_delete_caption (GdomHTMLTableElement *thiz);

WEBKIT_API GdomHTMLElement *
gdom_html_table_element_insert_row (GdomHTMLTableElement *thiz, glong index);

WEBKIT_API void
gdom_html_table_element_delete_row (GdomHTMLTableElement *thiz, glong index);

G_END_DECLS

#endif /* __GdomHTMLTableElement_H__ */
